<?php
/* Miranda Translator (Capture Library Class)
 * Copyright(C) 2004 Studio KUMA
 * 
 * This software is released under the terms and conditions of the GPL License V2.
 * For full license details, please refer to http://www.gnu.org/licenses/gpl.txt.
 *
 * Written by Stark Wong. Contact: starkwong@hotmail.com (E-mail and MSN)
 */

class Capture {
	function Capture($db) {
		include ('wordlist.inc.php');
		$this->db=$db;
		
		$this->fpInfo=fopen("autoplugin.inc.php","w");
		//fputs($this->fpInfo,"<"."? error_reporting(0); ?".">\n");
		
		$this->db->clearTempPhrases();

		$dir=dir("engines");
		while (false!==($entry=$dir->read())) {
			if (substr($entry,-8)=='.eng.php')
				include("engines/$entry");
		}
		
		$this->useplugindesc=$GLOBALS['conf']['out']['useplugindesc'];
	}
	
	function open($srcfile,$len) {
		$this->file=$srcfile;
		$this->relfile=substr($srcfile,$len);
		$this->fpIn=fopen($srcfile,"r");
		($this->fpIn) or ShowError (sprintf($GLOBALS['r_step1_openfail'],$srcfile));
		
		$this->added=0;
		$this->ignored=0;
		$this->blacklisted=0;
	}
	
	function _registerEngine($ext, $class) {
		$this->engines[$ext]=$class;
		$this->$class->setList($this->whitelist, $this->blacklist, $this->superlist);
	}
	
	function getExt($file) {
		if (strpos($file,'.')===false) 
			return false;
		else
			return substr($file,strrpos($file,'.')+1);
	}
	
	function isRegistered($ext) {
		return isset($this->engines[$ext]);
	}
	
	function getString() {
		$first=true;
				
		while (($str=$this->getNextString())!==false) {
			if ($this->db->isIgnoredPhrase($str)) {
				$this->blacklisted++;
			} else {
				if ($first) {
					$this->db->putTempPhrase("; ".$this->relfile);
					$first=false;
				}
				if ($this->db->putTempPhrase($str)) {
					if (substr($str,0,1)=='[') {
						$this->added++;
					} 
				} else {
					$this->ignored++;
				}
			}
		}
		
		$engine=$this->engines[$this->getExt($this->file)];
		if ($this->useplugindesc && $this->$engine->infoFound) {
			$path=substr($this->relfile,0,strrpos($this->relfile,'/')+1);
			$pluginname=$this->$engine->pluginname;
			$pluginver=$this->$engine->pluginver;
			if (isset($this->plugins[$path])) {
				$plugin=$this->plugins[$path];
				if ($plugin[0]) $pluginname=$plugin[0];
				if ($plugin[1]) $pluginver=$plugin[1];
			}
			fputs($this->fpInfo,'<'.'? $this->addInfo("'.$path.'","'.$this->$engine->plugindir.'",'.$pluginname.',$this->'.$pluginver.'); ?'.">\n");
		}
		
	}
	
	function getNextString() {
		$engine=$this->engines[$this->getExt($this->file)];
		return $this->$engine->getNextString($this->fpIn,$this->relfile,$this->file);
	}
	
	function close() {
		fclose($this->fpIn);
	}
	
}

function _capture_matchList($str,$list) {
	for($c=0;$c<count($list);$c++) {
		if (strpos($str,$list[$c])!==false)
			return true;
	}
	return false;
}	

function _capture_captureFromList($str,$list) {
	for($c=0;$c<count($list);$c++) {
		if (strpos($str,$list[$c])!==false)
			return substr($str,strpos($str,$list[$c]));
	}
	return false;
}	

?>
