<?
/* Miranda Translator (Common Functions and Includes)
 * Copyright(C) 2004 Studio KUMA
 * 
 * This software is released under the terms and conditions of the GPL License V2.
 * For full license details, please refer to http://www.gnu.org/licenses/gpl.txt.
 *
 * Written by Stark Wong. Contact: starkwong@hotmail.com (E-mail and MSN)
 *
 * 2005/1/11		Added unfixString() 
 */

$coreVersion="1.2 (29/1/2065)";
$clientVersion="0.0";

CheckConfig();

set_error_handler("ErrorHandlerWrapper",E_ALL);

require ('config.inc.php');
require ('language.inc.php');
require ('database.inc.php');

if (isset($conf['readme'])) {
	$conf['misc']['readme']=$conf['readme'];
}
if (isset($conf['excludelist'])) {
	$conf['misc']['excludelist']=$conf['excludelist'];
}

if (!isset($conf['misc'])) {
	$conf['misc']=array('readme'=>array(), 'excludelist'=>array());
}

set_time_limit(0);

function CheckConfig() {
	if (!is_file("config.inc.php")) {
		TestFile("config-default.inc.php","config.inc.php");
		TestFile("plugins-default.inc.php","plugins.inc.php");
		TestFile("wordlist-default.inc.php","wordlist.inc.php");
		
		(is_file("config.inc.php") && is_file("plugins.inc.php") && is_file("wordlist.inc.php")) or die("Failed to install config files! Please reinstall.");
		echo "New configuration files installed successfully. Please take a look and make any required adjustments.";
		include('config.php');
	}
}

function TestFile($s,$d) {
	if (!is_file($d)) {
		copy($s,$d);
		echo "Created $d from $s<br/>\n";
	}
}

function ErrorHandlerWrapper($errno, $errstr, $errfile, $errline, $errcontext) {
?>
<table style="border-style: solid; border-width: 1">
	<tr>
		<td style="background-color: silver; color: red">
			<?="[$errno] $errstr"?>
		</td>
	</tr>
	<tr>
		<td style="background-color: light gray">
			<?=sprintf($GLOBALS['rc']['errmsg'],$errfile,$errline)?><br/>
			Stack trace: 
<pre>
<? debug_print_backtrace() ?>
</pre>
		</td>
	</tr>
</table>
<?
}


function ShowError($classname,$msg='') {
	if ($msg=='')
		trigger_error($classname);
	else
		trigger_error($msg);
	die();
}

function FixPostString($str) {
	if (!isset($_POST['quotetest'])) ShowError("MT099[0217]  Fix your script!");
	if ($_POST['quotetest']=="'") return $str;
	 
	if (strpos($str,"\r\n")===false)
		$str=str_replace("\n","\r\n",$str);

	$str=str_replace("\\\\","\\",$str);
	$str=str_replace("\\'","'",$str);
	
	// The following line needs in-depth investigation
	$str=str_replace("\\\"","\"",$str);
	return $str;
} 
?>
