<?php
/* Miranda Translator (MySQL Database Driver)
 * Copyright(C) 2004, 2005 Studio KUMA
 * 
 * This software is released under the terms and conditions of the GPL License V2.
 * For full license details, please refer to http://www.gnu.org/licenses/gpl.txt.
 *
 * Written by Stark Wong. Contact: starkwong@hotmail.com (E-mail and MSN)
 *
 * 2005/2/5 	V1.11	Added $like to select function, parseCriteria() added $like
 */

require ('base.inc.php');

class MySQLDatabase extends BaseDB {
	function MySQLDatabase($conf) {
		global $rc; 
		$this->_conn=mysql_connect($conf['server'],$conf['user'],$conf['password'],$conf['database']);
		/*if (!$this->_conn) {
			if (isset($conf['autostart'])) {
				echo "Starting MySQL server by \"{$conf['autostart']}\"...<br/>\n";
				shell_exec($conf['autostart']." &");
				sleep(5);
				$this->_conn=mysql_connect($conf['server'],$conf['user'],$conf['password'],$conf['database']);
			} else
				ShowError($rc['db_noinit']);
		}*/
		$this->phraseUID=0;
		$this->conf=$conf;
		if (!$this->_conn) ShowError($rc['db_noinit']);
		if (!mysql_select_db($conf['database'],$this->_conn)) $this->checkTables();
		if (isset($conf['charset']) && trim($conf['charset'])!='') mysql_query("SET CHARACTER SET {$conf['charset']}",$this->_conn);
	}
	
	/* Basic Query Functions */
	
	function select($fields, $table, $criteria=NULL, $and=true, $suffix='', $nofetch=false, $like=false) {
		$query="SELECT ";
		if (is_array($fields)) {
			$query.='`'.implode('`,`',$fields).'`';
		} else
			$query.=$fields;
		
		if ($criteria && !is_array($criteria)) ShowError("Fix your script!");
		
		$query.=" FROM ".$this->getColumn($table).$this->parseCriteria($criteria,$and,$like)." $suffix";
		
		//echo "$query<br>";
		if ($nofetch) {
			return $this->execute($query);
		} else
			return $this->fetch($this->execute($query));
	}
	
	function execute($query) {
		$this->test();
		if (isset($GLOBALS['_mysql_showquery'])) echo "$query<br>";
		return mysql_query($query, $this->_conn);
	}
	
	function fetch($result,$keep=false) {
		$rs=NULL;
		if ($result) {
			while ($row=mysql_fetch_assoc($result)) {
				$rs[]=$row;
			}
			if (!$keep) mysql_free_result($result);
			return $rs;
		} else
			return false;		
	}
	
	function parseCriteria($criteria,$and,$like=false) {
		if (!$criteria) return "";
		if ($criteria && !is_array($criteria)) ShowError("Fix your script!");
		
		foreach (array_keys($criteria) as $key)
			$criteria[$key]=$this->getColumn($key).($like?" LIKE '":"='").$this->fixString($criteria[$key])."'";
		
		return " WHERE ".implode($and?' AND ':' OR ',$criteria);
	}
	
	function insert($table, $pairs) {
		$query="INSERT INTO $table";
		$keys=array_keys($pairs);
		if ($keys[0]!="0") {
			// Keyed array
			$query.=" (`".implode('`,`',$keys)."`)";
		}
		
		$query.=" VALUES ('";
		
		foreach ($keys as $key)
			$pairs[$key]=$this->fixString($pairs[$key]);
			
		$values=array_values($pairs);
		$query.=implode("','",$values);
		$query.="')";
		//echo "$query\n<br/>";
		return $this->execute($query);
	}
	
	function getColumn($str) {
		return "`$str`";
	}
	
	function close() {
		$this->test();
		mysql_close($this->_conn);
	}

	/* MT Functions */
	
	function putTempPhrase($phrase) {
		return $this->insert('temp_phrasesheet',array('key'=>$phrase));
	}
	
	function clearTempPhrases() {
		return ($this->delete('temp_phrasesheet') && $this->execute("ALTER TABLE temp_phrasesheet AUTO_INCREMENT=1"));
	}
	
	function putPhrase($phrase, $value) {
		return $this->insert('phrases',array('phrase'=>$phrase,'value'=>$value));
	}

	function putIgnorePhrase($phrase) {
		return $this->insert('ignoredphrases',array('phrase'=>$phrase));
	}
	
	function isIgnoredPhrase($phrase) {
		$result=$this->select(array('phrase'),'ignoredphrases',array('phrase'=>$phrase),NULL,NULL,true);
		if (!$result) {
			return false;
		} else {
			if (mysql_num_rows($result)>0) {
				mysql_free_result($result);
				return true;
			} else {
				mysql_free_result($result);
				return false;
			}
		}
	}

	function checkTables() {
		global $rc;
		 
		$this->execute("CREATE DATABASE {$this->conf['database']}") or die($rc['db_nocreate']);
		mysql_select_db($this->conf['database'],$this->_conn) or die($rc['db_noselete']);
		$this->execute("CREATE TABLE `ignoredphrases` (`seq` int(11) auto_increment, `phrase` blob NOT NULL, PRIMARY KEY (`seq`), UNIQUE KEY `key` (`phrase`(255)))") or die($rc['db_noip']);
		$this->execute("CREATE TABLE `phrases` (`seq` int(11) NOT NULL auto_increment, `phrase` blob NOT NULL, `value` text NOT NULL, PRIMARY KEY  (`seq`), UNIQUE KEY `key` (`phrase`(255)))") or die($rc['db_nop']);
		$this->execute("CREATE TABLE `temp_phrasesheet` (`seq` int(11) NOT NULL auto_increment, `key` blob NOT NULL, `value` text, PRIMARY KEY  (`seq`), UNIQUE KEY `key` (`key`(255)))") or die($rc['db_notp']);
	}
	
	function getVersionString() {
		return $GLOBALS['rc']['db_msver'].mysql_get_server_info($this->_conn);
	}
	
	function fixString($in) {
		// Convert control characters
		$out=str_replace("\\","\\\\",rtrim($in,"\n\r"));
		
		// Fix '
		$out=str_replace("'","''",$out);
		
		return $out;
	}
	
	function unfixString($in) {
		// Fix null
		$out=str_replace("\\\\","\\",$in);
		
		// Fix '
		$out=str_replace("''","'",$out);
	
		// Finished...
		return $out;
	
	} 
}

$dbclass="MySQLDatabase";

?>
