<?
/* Miranda Translator (C/CPP Process Engine)
 * Copyright(C) 2005 Studio KUMA
 * 
 * This software is released under the terms and conditions of the GPL License V2.
 * For full license details, please refer to http://www.gnu.org/licenses/gpl.txt.
 *
 * Written by Stark Wong. Contact: starkwong@hotmail.com (E-mail and MSN)
 *
 * Revision Information
 * 2005/ 3/12	Improved autoplugin engine to grab standalone version info in header files
 */

class CEngine {
	function CEngine() {
		$this->reset();
	}
	
	function reset() {
		$this->loc=0;
		$this->supermode=0;
		$this->strTemp='';
		$this->infoFound=false;
		$this->infoStatus=0;
	}
	
	function setList($whitelist,$blacklist,$superlist) {
		$this->whitelist=$whitelist;
		$this->blacklist=$blacklist;
		$this->superlist=$superlist;
	}
	
	function getNextString($fpIn,$relfile,$file) {
		if (ftell($fpIn)==0) $this->reset();
		
		if (feof($fpIn)) {
			return false;
		} else while (!feof($fpIn)) {
			if ($this->loc==-1) $this->strTemp=str_replace("\\\"",'^',fgets($fpIn,4096));
			if ($this->loc==-1) $this->loc=0;
			
			// Check for Info
			if ($this->loc==0 && $this->infoFound==false) {
				$str=trim(str_replace("\t",' ',$this->strTemp));
				while (strpos($str,'  ')!==false) $str=str_replace('  ',' ',$str);
				//if (strpos($str,'PLUGININFO')!==false) echo "$str<br>\n";
				if (strpos($str,'PLUGININFO plug')!==false && $this->infoStatus==0) {
					//echo "$str<br>\n";
					if (strpos($str,'sizeof'/*'sizeof(PLUGININFO)'*/)!==false)
						$this->infoStatus++;
					else
						do {
							$str=fgets($fpIn,4096);
							if (strpos($str,'sizeof'/*'sizeof(PLUGININFO)'*/)!==false) {
								$this->infoStatus++;
								break;
							}
						} while (strpos(trim($str),'//')!==false || strpos(trim($str),'{')!==false);
					
					//echo "$str<br>\n";
				} else if ($this->infoStatus==1 && trim($str)!='};' && substr($str,0,1)!='#' /*&& strpos($str,'"')!==false*/) {
					$this->pluginname=$str;
					$this->infoStatus++;
				} else if ($this->infoStatus==2 && trim($str)!='};' && substr($str,0,1)!='#' /*&& strpos($str,"PLUGIN_MAKE_VERSION")!==false*/) {
					if (strpos($str,'"')===false && strpos($str,'if')===false && strpos($str,'255')===false) {
						$this->pluginver=$str;
						$this->infoStatus++;
						$this->infoCheck($fpIn, $relfile, $file);
					}
				}
			}
			
			if (!$this->supermode && _capture_matchList($this->strTemp,$this->superlist)) {
				$this->supermode=true;
			} 
			if (strpos($this->strTemp,"\"",$this->loc)!==false && (_capture_matchList($this->strTemp,$this->whitelist)||$this->supermode)) {
				// String found
				$this->loc=strpos($this->strTemp,"\"",$this->loc)+1;
				$captured='~!~';
				if (strpos($this->strTemp,"\"",$this->loc)!==false) {
					$loc2=strpos($this->strTemp,"\"",$this->loc);
					$captured=str_replace('^','"',ltrim(rtrim(substr($this->strTemp,$this->loc,$loc2-$this->loc),"\n\r")));
					$this->loc=$loc2+1;
				}
				if ($captured!='~!~' && !_capture_matchList("\"$captured\"",$this->blacklist)) {
					return "[$captured]";
				} else if ($captured=='~!~')
					$this->loc=-1;
				
			} else
				$this->loc=-1;
			if ($this->supermode && strpos($this->strTemp,"};")!==false) {
				$this->supermode=false;
			}
		}
		return false;
	}
	
	function infoCheck($fpIn,$relfile,$file) {
		$this->infoFound=true;
		//$this->pluginname=substr($this->strTemp,strpos($this->strTemp,'"')+1);
		//$this->pluginname=trim(substr($this->pluginname,0,strpos($this->pluginname,'"')));
		//$this->pluginver=trim(substr($this->strTemp,0,strrpos($this->strTemp,',')));
		$this->pluginname=substr($this->pluginname,0,strlen($this->pluginname)-1);
		$this->pluginver=substr($this->pluginver,0,strlen($this->pluginver)-1);
		$this->plugindir=substr($relfile,0,strrpos($relfile,'/'));
		$this->plugindir=substr($this->plugindir,strrpos($this->plugindir,'/')+1);
		if (strpos($this->pluginname,'"')===false) {
			$this->pluginname=$this->scanString($fpIn, $relfile, $file, $this->pluginname);
		}
		if (strpos($this->pluginname,'//')!==false) {
			$this->pluginname=substr($this->pluginname,0,strpos($this->pluginname,'//'));
		}
		if (strpos($this->pluginname,'"')===false) {
			$this->pluginname="\"{$this->plugindir}\"";
		}
		if (strpos($this->pluginver,'PLUGIN_MAKE_VERSION')===false) {
			$this->pluginver=$this->scanString($fpIn, $relfile, $file, 'PLUGIN_MAKE_VERSION');
			if ($this->pluginver=='PLUGIN_MAKE_VERSION') $this->pluginver.='(0,0,0,0)';
			/*$r=error_reporting(0);
			$v="";
			@$v=@$this->{$this->pluginver};
			error_reporting($r); 
			if ($v=="") $this->pluginver="PLUGIN_MAKE_VERSION(0,0,0,0)";*/ 
		}
	}
	
	function scanString($fpIn, $relfile, $file, $target) {
		$found=false;
		$ret=$target;
		$pos=ftell($fpIn);
		$headers=NULL;
		$path=substr($file,0,strrpos($file,'/'));
		
		fseek($fpIn,0);
		while (ftell($fpIn)<$pos) {
			$str=trim(fgets($fpIn,4096));
			if (strpos($str,$target)!==false && strpos($str,'=')!==false) {
				// Target found
				$ret=substr($str,strpos($str,"=")+1);
				$ret=trim(substr($ret,0,strpos($ret,';')));
				$found=true;
				break;
			} else if (substr($str,0,8)=='#include' && strpos($str,'"')!==false) {
				$h=substr($str,strpos($str,'"')+1);
				$h=substr($h,0,strpos($h,'"'));
				if (strpos($h,'/')===false && is_file("$path/$h")) {
					$headers[]=$h;
				}
			}
		}
		
		if (!$found && is_array($headers)) {
			// Not found, try to reference in .h file
			//$filebase=substr($relfile,0,strrpos($relfile,'.')).".h";
			foreach (array_reverse($headers) as $h) {
				//echo "open $h<br>\n";
				$fp=fopen("$path/$h","r") or die();
				while (!feof($fp)) {
					$str=trim(fgets($fp),4096);
					$str=str_replace("\t",' ',$str);
					//echo "target=$target, str=$str<br>\n";
					if (strpos($str,$target)!==false && strpos($str,'=')!==false) {
						// Target found
						$ret=trim(substr($str,strpos($str,"=")+1));
						//die("found, str=$ret");
						$found=true;
						break;
					} else if (strpos($str,$target)!==false && substr($str,0,7)=='#define') {
						//echo "target=$target, str=$str<br>\n";
						$ret=substr($str,strpos($str,' ')+1);
						$ret=trim(substr(trim($ret),strpos($ret,' ')+1));
						if (strpos($ret,'//')!==false) $ret=trim(substr($ret,0,strpos($ret,'//')));
						$found=true;
						break;
					} else if ($target=="PLUGIN_MAKE_VERSION" && strpos($str,'#define')!==false && strpos($str,"FILEVER")!==false && strpos($str,',')!=false && strpos($str,'"')===false) {
						//echo "New method: target=$target, str=str<br>\n";
						$ret=trim(substr($str,strpos($str," ")));
						$ret="PLUGIN_MAKE_VERSION(".trim(substr($ret,strpos($ret," "))).")";
						$found=true;
						//echo "return=$ret<br>\n";
					}
				}
				fclose($fp);
				if ($found) break;
			}
		}
		fseek($fpIn,$pos);
		return $ret;
	}

	function PLUGIN_MAKE_VERSION($v1,$v2,$v3,$v4) {
		return "$v1.$v2.$v3.$v4";
	}
}
$this->_CEngine=new CEngine();

$this->_registerEngine('c','_CEngine');
$this->_registerEngine('cpp','_CEngine');
$this->_registerEngine('h','_CEngine');
?>
