<?php
/* Miranda Translator (Import Library Class)
 * Copyright(C) 2004 Studio KUMA
 * 
 * This software is released under the terms and conditions of the GPL License V2.
 * For full license details, please refer to http://www.gnu.org/licenses/gpl.txt.
 *
 * Written by Stark Wong. Contact: starkwong@hotmail.com (E-mail and MSN)
 *
 * 2005/1/17	Fixed typing mistake on html_entity_decode()
 * 2005/1/13	Hopefully fixed display of strings with < and > sign
 * 2005/ 6/30	Suppressed warning for phrases without value
 */

class Importer {
	function Importer($src,$db) {
		$this->fpIn=fopen($src,'r');
		if (!$this->fpIn) ShowError (__FILE__, "Failed to open $src for reading!");
		$this->db=$db;
	}
	
	function import() {
		if (!$this->fpIn) ShowError (__FILE__, "You must first open source file!");
		$lastKey='';
		$lastValue='';
		$conflicts=Array();
		$this->imported=0;
		$this->count=0;
		while (true) {
			$tmpStr=fgets($this->fpIn,4096);
			if (feof($this->fpIn)) $tmpStr='[null]';
			
			if (substr($tmpStr,0,1)==';') continue;
			if (substr($tmpStr,0,1)=='[') {
				if ($lastKey!='') {
					//$lastKey=fixString($lastKey);
					$lastValue=$lastValue;
					$this->count++;
					if (trim($lastValue)=='') {
						// No Value!
						/*echo "No Value!<br>";
						$conflicts[]=Array(
							'uid'=>-1,
							'keyName'=>html_entity_decode($lastKey),
							'oldValue'=>NULL,
							'newValue'=>NULL
						);*/					
					} else if (!$this->db->putPhrase($lastKey,$lastValue)) {
						$ori=$this->db->findPhrase($lastKey);
						if (trim($ori)!=trim($lastValue)) {
							$conflicts[]=Array(
								'uid'=>$this->db->phraseUID,
								'keyName'=>html_entity_decode($lastKey),
								'oldValue'=>html_entity_decode($ori),
								'newValue'=>html_entity_decode($lastValue)
							);

						}
					} else
						$this->imported++;
				}
				$lastKey=$tmpStr;
				$lastValue='';
			} else
				$lastValue.=$tmpStr;
			
			if (feof($this->fpIn)) break;
		}
		// To be fixed
		/*if ($lastKey!='') {
			//$lastKey=fixString($lastKey);
			$lastValue=fixString($lastValue);
			
			if (!$this->db->putPhrase($lastKey,$lastValue)) {
				$ori=$this->db->findPhrase($lastKey);
				if ($ori!=$lastValue) {
					$item[0]=$lastKey;
					$item[1]=$ori;
					$item[2]=$lastValue;
					$conflicts[]=$item;
				}
			}
		}*/
		return $conflicts;
	}
	
	function close() {
		if ($this->fpIn) fclose($this->fpIn);
	}

}
?>
